import React, { useState } from "react";
import Head from "next/head";
import ProfileLayout from "@/components/modules/profileLayout";
import NoProfileMenuData from "@/components/modules/noProfileMenuData";
import MyPlansPageDetails from "@/components/rendering/profilePageSections/myPlansPageDetails";
import { getESimList, getEsimPlans } from "@/utils/api/auth";
import { parseCookies } from "nookies";

export default function MyPlansPage({
  response,
  esimPlansResponse,
  iccid,
}: any) {
  const [eSimList, setESimList] = useState<any>(response);
  return (
    <>
      <Head>
        <title>WaoSim | My Plans</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" href="/faviconIcon.svg" />
      </Head>
      <main>
        <ProfileLayout>
          {eSimList ? (
            <MyPlansPageDetails
              eSimList={eSimList}
              eSimPlansData={esimPlansResponse}
              iccid={iccid}
            />
          ) : (
            <NoProfileMenuData
              mainTitle={`Plans`}
              backgroundImage={
                "https://stagecdn.waosim.com/myprofile/noPlanCardImage.png"
              }
              middleTitle={`No eSim`}
              buttonTitle={`Discover Now`}
              buttonLink={`/plans`}
            />
          )}
        </ProfileLayout>{" "}
      </main>
    </>
  );
}

export async function getServerSideProps(context: any) {
  const { req, query } = context;
  const cookies = parseCookies({ req });

  const { iccid } = query;

  if (!cookies?.waotoken) {
    return {
      redirect: {
        destination: "/auth/login",
        permanent: false,
      },
    };
  }

  const { isError, response } = await getESimList({
    waotoken: cookies?.waotoken,
  });

  let payload = {
    waotoken: cookies?.waotoken,
    iccid: iccid ? iccid : await response?.data[0]?.iccid,
  };
  const { isErrors, esimPlansResponse } = await getEsimPlans(payload);

  return {
    props: {
      response: response?.data?.length > 0 ? response?.data : null,
      esimPlansResponse: esimPlansResponse || null,
      iccid: iccid ?? null,
    },
  };
}
